@import 'variables';

@mixin media($width) {
    @media only screen and
        (max-width: $width) {
        @content;
    }
}

@mixin flex(
    $display: flex,
    $direction: null,
    $justify: null,
    $align: null,
    $flex: null
) {
    display: $display;
    flex-direction: $direction;
    justify-content: $justify;
    align-items: $align;
    flex: $flex;
}

@mixin border(
    $style: solid,
    $width: null,
    $color: null,
    $radius: null
) {
    @if ($color) {
        border: $style $color;
    }

    border-width: $width;
    border-radius: $radius;
}

// Note: this follows standard shorthand behaviour
//       @include size       === {width: 0; height: 0}
//       @include size(w)    === {width: w; height: w}
//       @include size(w, h) === {width: w; height: h}

@mixin size(
    $width: 0,
    $height: null
) {
    @if ($height) {
        width: $width;
        height: $height;
    }

    @else {
        width: $width;
        height: $width;
    }
}

// Note: this is a clone of the inset property,
//       allows easy cross-browser support

@mixin inset(
    $top: 0,
    $right: null,
    $bottom: null,
    $left: null
) {
    @if ($right) {
        @if ($bottom) {
            top: $top;
            right: $right;
            bottom: $bottom;
            left: $left;
        }

        @else {
            top: $top;
            right: $right;
            bottom: $top;
            left: $right;
        }
    }

    @else {
        top: $top;
        right: $top;
        bottom: $top;
        left: $top;
    }
}